#include "platform_win_posix.h"
#include "mp_wrap.h"

MP_Emitter* cur=NULL;

bool IsLost()
{
	MP_Manager& MP=MP_Manager::GetInstance();
	MP.device->is_lost=true;

	return false;
}

bool FrameFunc()
{
	MP_Manager& MP=MP_Manager::GetInstance();
	HGE* hge=MP.device->GetHGE();

	if (hge->Input_GetKeyState(HGEK_ESCAPE))
		return true;

	MP.UpdateByTimer();

	if (cur->GetState()==MAGIC_STATE_STOP)
	{
		cur=cur->GetNext();
		if (!cur)
			cur=MP.GetFirstEmitter();

		cur->SetState(MAGIC_STATE_UPDATE);
	}

	return false;
}

bool RenderFunc()
{
	MP_Manager::GetInstance().Render();
	return false;
}


int APIENTRY WinMain(HINSTANCE hInstance,
					 HINSTANCE hPrevInstance,
					 LPTSTR    lpCmdLine,
					 int       nCmdShow)
{
	HGE* hge=hgeCreate(HGE_VERSION);

	hge->System_SetState(HGE_FRAMEFUNC, FrameFunc);

	hge->System_SetState(HGE_RENDERFUNC, RenderFunc);

	hge->System_SetState(HGE_GFXRESTOREFUNC, IsLost);

	hge->System_SetState(HGE_TITLE, "Magic Particles (www.astralax.com) wrapper for HGE");

	hge->System_SetState(HGE_WINDOWED, true);

	hge->System_SetState(HGE_USESOUND, false);

	hge->System_SetState(HGE_FPS,HGEFPS_UNLIMITED);

	hge->System_SetState(HGE_HIDEMOUSE, false);

	int client_wi=800;
	int client_he=600;
	hge->System_SetState(HGE_SCREENWIDTH,client_wi);
	hge->System_SetState(HGE_SCREENHEIGHT,client_he);
	hge->System_SetState(HGE_TEXTUREFILTER,false);

	if(hge->System_Initiate())
	{
		MP_Device_WRAP device(client_wi,client_he,hge);
		device.Create();

		MP_Manager& MP=MP_Manager::GetInstance();

		MP_Platform* platform=new MP_Platform_WIN_POSIX;

		bool filters[MAGIC_RENDER_STATE__MAX];
		for (int i=0;i<MAGIC_RENDER_STATE__MAX;i++)
			filters[i]=false;
		filters[MAGIC_RENDER_STATE_BLENDING]=true;
		filters[MAGIC_RENDER_STATE_TEXTURE]=true;
		MP.Initialization(filters, true, MAGIC_pXpY, platform, MAGIC_INTERPOLATION_ENABLE, MAGIC_CHANGE_EMITTER_DEFAULT, 1024, 1024, 1, 1.f, 0.1f, true);

		// eng: find of all ptc-files in folder
		// rus:   ptc-  
		MP.LoadAllEmitters();

		MP.RefreshAtlas();

		MP.CloseFiles();

		MP.Stop();

		cur=MP.GetFirstEmitter();

		cur->SetState(MAGIC_STATE_UPDATE);

		// eng: locate emitters the same as editor
		// rus:   ,     
		MP_Emitter* emitter=MP.GetFirstEmitter();
		while(emitter)
		{
			Magic_CorrectEmitterPosition(emitter->GetEmitter(), client_wi, client_he);
			emitter=emitter->GetNext();
		}

		hge->System_Start();

		MP.Destroy();
		device.Destroy();
	}
	else
	{
		MessageBox(NULL, hge->System_GetErrorMessage(), "Error", MB_OK | MB_ICONERROR | MB_APPLMODAL);
	}

	hge->System_Shutdown();
	hge->Release();

	return 0;
}
